;
; DIRECTIVES
;
.686P
.MMX
.XMM
.MODEL flat, stdcall
.STACK 4096

OPTION SCOPED
OPTION LJMP
OPTION CASEMAP:NONE


;
; INCLUDES
;
INCLUDE \Masm32\INCLUDE\windows.inc
INCLUDE \Masm32\INCLUDE\kernel32.inc
INCLUDE \MAsm32\INCLUDE\masm32.inc
INCLUDE \Masm32\INCLUDE\user32.inc


;
; LIBRARIES
;
INCLUDELIB \Masm32\LIB\kernel32.lib
INCLUDELIB \Masm32\LIB\user32.lib
INCLUDELIB \MAsm32\LIB\masm32.lib


;
; CONSTANTS
;
IDD_MainDlgBox			EQU 1000
IDC_MainDlgBoxCprght	EQU 1001
IDC_HighScoreTxt		EQU 1002
IDC_HighScore			EQU 1003
IDC_CurrentScoreTxt		EQU 1004
IDC_CurrentScore		EQU 1005
IDC_RndVal			EQU 1006
IDC_BttnOdd			EQU 1007
IDC_AltTxt			EQU 1008
IDC_BttnEven			EQU 1009
IDC_Messages			EQU 1010

IDD_Nooo				EQU 1050
IDC_NoooCprght			EQU 1051
IDC_NoooTxt			EQU 1052
IDC_NoooBttn			EQU 1053

;
; PROTOS
;


.DATA
;
; STRUCTURES
;


.DATA
;
; VARIABLES
;
DlgBoxInst	DWORD ?
WndDlg		DWORD ?
Seed			DWORD ?
RndValue		DWORD ?
HighestScore	DWORD 15
YourScore		DWORD 0

szHighScore	BYTE 0,0,0,0,0,0,0,0,0,0,0,0
szCurrentScore	BYTE 0,0,0,0,0,0,0,0,0,0,0,0
szRndValue	BYTE 0,0,0,0,0,0,0,0,0,0,0,0,0,0
szEndStr		BYTE " ?",0
szMessages	BYTE 256 DUP (?)

szStartMessage	BYTE "Odd or Even ? make a judicious choice ;)",0
szMessageX2	BYTE "Oh my god, you beat me...",0
szMessageX5	BYTE "COMBO x5 GREAT ! :)",0
szMessageX10	BYTE "COMBO x10 it's just AMAZING !! :P",0
szMessageX20	BYTE "COMBO x20 you've just exploded ALL THE RECORDS !!! :D",0
szMessageX50	BYTE ":( I stop counting..., YOU ARE COMPLETLY MAD !!!!",0


.CODE
;
; PROCEDURES
;


ALIGN 16
;
; convert a value to decimal ascii string
;
; syntax :
; mov eax,Value
; mov esi,OFFSET String
; call GetRndmNbr
;
; Return :
; eax = string lenght
;
DwordToAscii PROC
		push ebx
		push ecx
		push edx
		push esi

		mov ecx,eax		; place o copy of the value in ecx
		inc eax
		jz SpecialCase
; we divide eax by 100000 (in optimized mehod)
		mov edx,2814749767
		sub esi,5
		mul edx
		shr edx,16
		mov eax,100000
		mov ebx,edx		; copy the higher part in ebx
; remultiply it by 100000 (to substract to the original value, to obtain the lower part)
		mul edx
		sub ecx,eax
		test ebx,ebx
		mov edx,ebx
		mov ebx,10
		jz Label01
; higher part of the value :
		mov eax,429497
		add esi,5
		mul edx
		jc Label02
		dec esi
		mul ebx
		jc Label03
		dec esi
		mul ebx
		jc Label04
		dec esi
		mul ebx
		jc Label05
		dec esi
		jmp Label06
; lower part of the value :
Label01:	mov eax,429497
		mul ecx
		jc Label07
		dec esi
		mul ebx
		jc Label08
		dec esi
		mul ebx
		jc Label09
		dec esi
		mul ebx
		jc Label10
		dec esi
		jmp Label11
; here XXXXXXXXXX and the final zero
Label02:	add dl,30h
		mov BYTE PTR [esi],dl
		mul ebx
Label03:	add dl,30h
		mov BYTE PTR [esi+1],dl
		mul ebx
Label04:	add dl,30h
		mov BYTE PTR [esi+2],dl
		mul ebx
Label05:	add dl,30h
		mov BYTE PTR [esi+3],dl
Label06:	mul ebx
		add dl,30h
		mov BYTE PTR [esi+4],dl
		mov eax,429497
		mul ecx
Label07:	add dl,30h
		mov BYTE PTR [esi+5],dl
		mul ebx
Label08:	add dl,30h
		mov BYTE PTR [esi+6],dl
		mul ebx
Label09:	add dl,30h
		mov BYTE PTR [esi+7],dl
		mul ebx
Label10:	add dl,30h
		mov BYTE PTR [esi+8],dl
Label11:	mul ebx
		add dx,30h
		mov WORD PTR [esi+9],dx
		lea eax,[esi+10]

		pop esi
		pop edx
		pop ecx
		pop ebx
		sub eax,esi
	ret
;ALIGN 4
SpecialCase:
		mov DWORD PTR [esi],"4924"
		mov DWORD PTR [esi+4],"2769"
		mov WORD PTR [esi+8],"59"
		mov BYTE PTR [esi+10],0

		pop esi
		pop edx
		pop ecx
		pop ebx
		mov eax,10
	ret
DwordToAscii ENDP


ALIGN 16
;
; generate a random number
;
; syntax :
; mov ebx,Range
; call GetRndmNbr
;
; Return :
; eax = desired random number
;
GetRndmNbr PROC
		push edx

		mov eax,987654321	; a x value
		mul Seed			; multiply eax by your Seed
		bswap eax			; swap bytes (to not have a too easy suit)
		xor eax,078787878h	; apply a mask
		mov Seed,eax		; save the new RndmNbr as Seed, for next use
; a range ?
		inc ebx
		jz Label2			; if not jump Label2
; here a range :
		mul ebx			; mul by range+1
		mov eax,edx		; return the result in eax
; exit
Label2:	dec ebx			; restore ebx

		pop edx
	ret
GetRndmNbr ENDP


ALIGN 16
;
; Initialise the random numbers
;
; syntax :
; call InitRndmNbr
;
; Return:
; eax = number of ticks since the computer started, and Seed defined
;
InitRndmNbr PROC
		push ecx
		push edx

		invoke GetTickCount
		test eax,eax		; ) to be sure it's not zero (it's possible ! if you launch the program 48 days after you've started the computer, lol)
		jnz Label1		; ) (and depending of the radom number routine, some really don't like zeros...)
		mov eax,123456789	; )
Label1:	mov Seed,eax		; save the seed

		pop edx
		pop ecx
	ret
InitRndmNbr ENDP




ALIGN 16
;
; add a string to another string
;
; syntax :
; mov esi, = adresse de la chane source que l'on ajoutera
; mov edi, = adresse de la chane de destination
; call  StringAdd
;
; Return :
; eax = string lenght
;
StringAdd PROC
		push ecx
		push edx
		push edi

; find the final zero
Label1:	mov eax,DWORD PTR [edi]
		add edi,4
		lea edx,[eax-01010101h]
		xor eax,edx
		and eax,80808080h
		jz Label1
		and eax,edx
		jz Label1
		bsf edx,eax
		sub edx,4
		shr edx,3
		lea edi,[edi+edx-4]
; and do the copy
		xor eax,eax
		jmp Label3
Label2:	add ecx,01010101h
		mov DWORD PTR [edi+eax],ecx
		add eax,4
Label3:	mov edx,DWORD PTR [esi+eax]
		lea ecx,[edx-01010101h]
		xor edx,ecx
		and edx,80808080h
		jz Label2
		and edx,ecx
		jz Label2
		add ecx,01010101h
		mov [edi+eax],cl
		test cl,cl
		jz Label6
		mov [edi+eax+1],ch
		test ch,ch
		jz Label5
		shr ecx,16
		mov [edi+eax+2],cl
		test cl,cl
		jz Label4
		mov [edi+eax+3],ch
		inc eax
Label4:	inc eax
Label5:	inc eax
Label6:	add eax,edi

		pop edi
		pop edx
		pop ecx
		sub eax,edi
	ret
StringAdd ENDP


ALIGN 16
;
; copy a string to another location
;
; syntax : StringCopy
;
; mov esi,OFFSET SourceString
; mov edi,OFFSET DestinationString
; call StringCopy
;
; Return :
; eax = string lenght
;
StringCopy PROC
		push ecx
		push edx

		xor eax,eax
		jmp Label2
Label1:	add edx,01010101h
		mov DWORD PTR [edi+eax],edx
		add eax,4
Label2:	mov ecx,DWORD PTR [esi+eax]
		lea edx,[ecx-01010101h]
		xor ecx,edx
		and ecx,80808080h
		jz Label1
		and ecx,edx
		jz Label1
		add edx,01010101h
		mov [edi+eax],dl
		test dl,dl
		jz Label5
		mov [edi+eax+1],dh
		test dh,dh
		jz Label4
		shr edx,16
		mov [edi+eax+2],dl
		test dl,dl
		jz Label3
		mov [edi+eax+3],dh
		inc eax
Label3:	inc eax
Label4:	inc eax
Label5:
		pop edx
		pop ecx
	ret
StringCopy ENDP


ALIGN 16
;
; 
;
UpdateDlgBox PROC

; update scores
		inc YourScore
		mov eax,YourScore
		cmp eax,HighestScore
		jbe Avoid_UpdateHighestScore
		mov HighestScore,eax
;		mov eax,				; already done
		mov esi,OFFSET szHighScore
		call DwordToAscii
		mov eax,YourScore
Avoid_UpdateHighestScore:
;		mov eax,				; already done
		mov esi,OFFSET szCurrentScore
		call DwordToAscii
; generate new random value
		mov ebx,0FFFFFFFFh
		call GetRndmNbr
		mov RndValue,eax
;		mov eax,				; already done
		mov esi,OFFSET szRndValue
		call DwordToAscii
; add " ?" to the string of the random value
		mov esi,OFFSET szEndStr
		mov edi,OFFSET szRndValue
		call StringAdd
; test messages to send
		mov eax,YourScore
		cmp eax,2
		jne Avoid_MessageX2
		mov esi,OFFSET szMessageX2
		mov edi,OFFSET szMessages
		call StringCopy
Avoid_MessageX2:
		cmp eax,5
		jne Avoid_MessageX5
		mov esi,OFFSET szMessageX5
		mov edi,OFFSET szMessages
		call StringCopy
Avoid_MessageX5:
		cmp eax,10
		jne Avoid_MessageX10
		mov esi,OFFSET szMessageX10
		mov edi,OFFSET szMessages
		call StringCopy
Avoid_MessageX10:
		cmp eax,20
		jne Avoid_MessageX20
		mov esi,OFFSET szMessageX20
		mov edi,OFFSET szMessages
		call StringCopy
Avoid_MessageX20:
		cmp eax,50
		jne Avoid_MessageX50
		mov esi,OFFSET szMessageX50
		mov edi,OFFSET szMessages
		call StringCopy
Avoid_MessageX50:
; and update dialog box controls
		invoke SetDlgItemText,WndDlg,IDC_HighScore,ADDR szHighScore
		invoke SetDlgItemText,WndDlg,IDC_CurrentScore,ADDR szCurrentScore
		invoke SetDlgItemText,WndDlg,IDC_RndVal,ADDR szRndValue
		invoke SetDlgItemText,WndDlg,IDC_Messages,ADDR szMessages
		invoke UpdateWindow,WndDlg
	ret
UpdateDlgBox ENDP


ALIGN 16
;
;
;
WndDlg2Proc PROC HWndDlg2:HWND,Message:UINT,WParam:WPARAM,LParam:LPARAM
		mov eax,Message

; COMMAND
		cmp eax,WM_COMMAND
		jne Avoid_Command_2
		mov eax,WParam
; you loose !
		cmp eax,IDC_NoooBttn
		jne Avoid_ReInit
		mov YourScore,0
		invoke EndDialog,HWndDlg2,0
		invoke SendMessage,WndDlg,WM_INITDIALOG,NULL,NULL
	ret
Avoid_ReInit:


Avoid_Command_2:
		xor eax,eax
	ret
WndDlg2Proc ENDP


;
;
;
WndDlgProc PROC HWndDlg:HWND,Message:UINT,WParam:WPARAM,LParam:LPARAM
		mov eax,Message

; INITDIALOG
		cmp eax,WM_INITDIALOG
		jne Avoid_InitDialog
		invoke LoadIcon,HWndDlg,500
		invoke SetClassLong,HWndDlg,GCL_HICON,eax
		mov eax,HWndDlg
		mov WndDlg,eax
; init strings
		mov eax,HighestScore
		mov esi,OFFSET szHighScore
		call DwordToAscii
		mov eax,YourScore
		mov esi,OFFSET szCurrentScore
		call DwordToAscii
; generate a random value
		mov ebx,0FFFFFFFFh
		call GetRndmNbr
		mov RndValue,eax
;		mov eax,				; already done
		mov esi,OFFSET szRndValue
		call DwordToAscii
; add " ?" to the string of the random value
		mov esi,OFFSET szEndStr
		mov edi,OFFSET szRndValue
		call StringAdd
; define start message
		mov esi,OFFSET szStartMessage
		mov edi,OFFSET szMessages
		call StringCopy
; and update dialog box controls
		invoke SetDlgItemText,HWndDlg,IDC_HighScore,ADDR szHighScore
		invoke SetDlgItemText,HWndDlg,IDC_CurrentScore,ADDR szCurrentScore
		invoke SetDlgItemText,HWndDlg,IDC_RndVal,ADDR szRndValue
		invoke SetDlgItemText,HWndDlg,IDC_Messages,ADDR szMessages
		invoke UpdateWindow,HWndDlg
	ret
Avoid_InitDialog:

; COMMAND
		cmp eax,WM_COMMAND
		jne Avoid_Command
		mov eax,WParam
		cmp eax,2
		je Quit
; ODD ?
			cmp eax,IDC_BttnOdd
			jne Avoid_Odd
			bt RndValue,0
			jnc OddError
			call UpdateDlgBox
			jmp OddNoError
OddError:		invoke MessageBeep,0FFFFFFFFh	; 0FFFFFFFFh / MB_ICONASTERISK / MB_ICONEXCLAMATION / MB_ICONHAND / MB_ICONQUESTION / MB_OK
			invoke DialogBoxParam,DlgBoxInst,IDD_Nooo,0,ADDR WndDlg2Proc,0
OddNoError:	xor eax,eax
	ret
Avoid_Odd:
; EVEN ?
			cmp eax,IDC_BttnEven
			jne Avoid_Even
			bt RndValue,0
			jc EvenError
			call UpdateDlgBox
			jmp EvenNoError
EvenError:	invoke MessageBeep,0FFFFFFFFh	; 0FFFFFFFFh / MB_ICONASTERISK / MB_ICONEXCLAMATION / MB_ICONHAND / MB_ICONQUESTION / MB_OK
			invoke DialogBoxParam,DlgBoxInst,IDD_Nooo,0,ADDR WndDlg2Proc,0
EvenNoError:	xor eax,eax
	ret
Avoid_Even:

DefaultCommandMsg:
			xor eax,eax
	ret
Avoid_Command:

; CLOSE
		cmp eax,WM_CLOSE
		jne Avoid_Close
Quit:
		invoke EndDialog,HWndDlg,0
	ret
Avoid_Close:


DefaultMsg:
		xor eax,eax
	ret
WndDlgProc ENDP


;
; PROGRAM ENTRY POINT
;
OddOrEven:
		invoke GetModuleHandle,0
		mov DlgBoxInst,eax
		call InitRndmNbr
		invoke DialogBoxParam,DlgBoxInst,IDD_MainDlgBox,0,ADDR WndDlgProc,0
		invoke ExitProcess,0
;
END OddOrEven

